org.encog.ml.prg.extension

## Class StandardExtensions

- java.lang.Object
- - org.encog.ml.prg.extension.StandardExtensions

-     public class StandardExtensions
      extends Object

  This class defines the standard opcodes for Encog programs. The operator precedence is based on the following article. http://en.wikipedia.org/wiki/Operators_in_C_and_C%2B%2B#Operator_precedence

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static ProgramExtensionTemplate` | `EXTENSION_ABS` Standard numeric absolute value function.
    `static ProgramExtensionTemplate` | `EXTENSION_ACOS` Standard numeric acos function.
    `static ProgramExtensionTemplate` | `EXTENSION_ADD` Standard binary add operator.
    `static ProgramExtensionTemplate` | `EXTENSION_AND` Standard boolean binary and operator.
    `static ProgramExtensionTemplate` | `EXTENSION_ASIN` Standard numeric asin function.
    `static ProgramExtensionTemplate` | `EXTENSION_ATAN` Standard numeric atan function.
    `static ProgramExtensionTemplate` | `EXTENSION_ATAN2` Standard numeric atan2 function.
    `static ProgramExtensionTemplate` | `EXTENSION_CBOOL` Standard string cbool function.
    `static ProgramExtensionTemplate` | `EXTENSION_CEIL` Standard numeric ceil function.
    `static ProgramExtensionTemplate` | `EXTENSION_CFLOAT` Standard string cfloat function.
    `static ProgramExtensionTemplate` | `EXTENSION_CINT` Standard string cint function.
    `static ProgramExtensionTemplate` | `EXTENSION_CLAMP` Standard string clamp function.
    `static ProgramExtensionTemplate` | `EXTENSION_CONST_SUPPORT` Numeric const.
    `static ProgramExtensionTemplate` | `EXTENSION_COS` Standard numeric cos function.
    `static ProgramExtensionTemplate` | `EXTENSION_COSH` Standard numeric cosh function.
    `static ProgramExtensionTemplate` | `EXTENSION_CSTR` Standard string cstr function.
    `static ProgramExtensionTemplate` | `EXTENSION_DIV` Standard binary div operator.
    `static ProgramExtensionTemplate` | `EXTENSION_EQUAL` Standard boolean binary equal operator.
    `static ProgramExtensionTemplate` | `EXTENSION_EXP` Standard numeric exp function.
    `static ProgramExtensionTemplate` | `EXTENSION_FLOOR` Standard numeric floor function.
    `static ProgramExtensionTemplate` | `EXTENSION_FORMAT` Numeric formatting function.
    `static ProgramExtensionTemplate` | `EXTENSION_GT` Standard boolean binary greater than operator.
    `static ProgramExtensionTemplate` | `EXTENSION_GTE` Standard boolean binary greater than operator.
    `static ProgramExtensionTemplate` | `EXTENSION_IFF` Standard string iff function.
    `static ProgramExtensionTemplate` | `EXTENSION_LEFT` String left function.
    `static ProgramExtensionTemplate` | `EXTENSION_LENGTH` Standard string length function.
    `static ProgramExtensionTemplate` | `EXTENSION_LOG` Standard numeric log function.
    `static ProgramExtensionTemplate` | `EXTENSION_LOG10` Standard numeric log10 function.
    `static ProgramExtensionTemplate` | `EXTENSION_LT` Standard boolean binary less than operator.
    `static ProgramExtensionTemplate` | `EXTENSION_LTE` Standard boolean binary less than operator.
    `static ProgramExtensionTemplate` | `EXTENSION_MAX` Standard numeric max function.
    `static ProgramExtensionTemplate` | `EXTENSION_MIN` Standard numeric max function.
    `static ProgramExtensionTemplate` | `EXTENSION_MUL` Standard binary multiply operator.
    `static ProgramExtensionTemplate` | `EXTENSION_NEG` Standard unary minus operator.
    `static ProgramExtensionTemplate` | `EXTENSION_NOT` Standard boolean binary and operator.
    `static ProgramExtensionTemplate` | `EXTENSION_NOT_EQUAL` Standard boolean not equal operator.
    `static ProgramExtensionTemplate` | `EXTENSION_OR` Standard boolean binary or operator.
    `static ProgramExtensionTemplate` | `EXTENSION_PDIV` Standard binary protected div operator.
    `static ProgramExtensionTemplate` | `EXTENSION_POWER` Standard binary power operator.
    `static ProgramExtensionTemplate` | `EXTENSION_POWFN` Standard numeric pow function.
    `static ProgramExtensionTemplate` | `EXTENSION_RANDOM` Standard numeric random function.
    `static ProgramExtensionTemplate` | `EXTENSION_RIGHT` String right function.
    `static ProgramExtensionTemplate` | `EXTENSION_ROUND` Standard numeric log10 function.
    `static ProgramExtensionTemplate` | `EXTENSION_SIN` Standard numeric sin function.
    `static ProgramExtensionTemplate` | `EXTENSION_SINH` Standard numeric sinh function.
    `static ProgramExtensionTemplate` | `EXTENSION_SQRT` Standard numeric sqrt function.
    `static ProgramExtensionTemplate` | `EXTENSION_SUB` Standard binary sub operator.
    `static ProgramExtensionTemplate` | `EXTENSION_TAN` Standard numeric tan function.
    `static ProgramExtensionTemplate` | `EXTENSION_TANH` Standard numeric tanh function.
    `static ProgramExtensionTemplate` | `EXTENSION_TODEG` Standard numeric toDegrees function.
    `static ProgramExtensionTemplate` | `EXTENSION_TORAD` Standard numeric toRadians function.
    `static ProgramExtensionTemplate` | `EXTENSION_VAR_SUPPORT` Variable support.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `StandardExtensions()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `createAll(EncogProgramContext context)` Add all known opcodes to a context.
    `static void` | `createBasicFunctions(EncogProgramContext context)` Add the opcodes for basic operations to a context.
    `static void` | `createBooleanOperators(EncogProgramContext context)` Add the opcodes for boolean operations to a context.
    `static void` | `createConversionFunctions(EncogProgramContext context)` Add the opcodes for type conversion operations to a context.
    `static void` | `createNumericOperators(EncogProgramContext context)` Add the opcodes for numeric operations to a context, do not use protected division.
    `static void` | `createNumericOperators(EncogProgramContext context, boolean protectedDiv)` Add the opcodes for numeric operations to a context.
    `static void` | `createStringFunctions(EncogProgramContext context)` Add the opcodes for string operations to a context.
    `static void` | `createTrigFunctions(EncogProgramContext context)` Add the opcodes for trig functions operations to a context.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### EXTENSION_VAR_SUPPORT

          public static ProgramExtensionTemplate EXTENSION_VAR_SUPPORT

      Variable support.

    - #### EXTENSION_CONST_SUPPORT

          public static ProgramExtensionTemplate EXTENSION_CONST_SUPPORT

      Numeric const.

    - #### EXTENSION_NEG

          public static ProgramExtensionTemplate EXTENSION_NEG

      Standard unary minus operator.

    - #### EXTENSION_ADD

          public static ProgramExtensionTemplate EXTENSION_ADD

      Standard binary add operator.

    - #### EXTENSION_SUB

          public static ProgramExtensionTemplate EXTENSION_SUB

      Standard binary sub operator.

    - #### EXTENSION_MUL

          public static ProgramExtensionTemplate EXTENSION_MUL

      Standard binary multiply operator.

    - #### EXTENSION_DIV

          public static ProgramExtensionTemplate EXTENSION_DIV

      Standard binary div operator.

    - #### EXTENSION_PDIV

          public static ProgramExtensionTemplate EXTENSION_PDIV

      Standard binary protected div operator.

    - #### EXTENSION_POWER

          public static ProgramExtensionTemplate EXTENSION_POWER

      Standard binary power operator.

    - #### EXTENSION_AND

          public static ProgramExtensionTemplate EXTENSION_AND

      Standard boolean binary and operator.

    - #### EXTENSION_NOT

          public static ProgramExtensionTemplate EXTENSION_NOT

      Standard boolean binary and operator.

    - #### EXTENSION_OR

          public static ProgramExtensionTemplate EXTENSION_OR

      Standard boolean binary or operator.

    - #### EXTENSION_EQUAL

          public static ProgramExtensionTemplate EXTENSION_EQUAL

      Standard boolean binary equal operator.

    - #### EXTENSION_NOT_EQUAL

          public static ProgramExtensionTemplate EXTENSION_NOT_EQUAL

      Standard boolean not equal operator.

    - #### EXTENSION_GT

          public static ProgramExtensionTemplate EXTENSION_GT

      Standard boolean binary greater than operator.

    - #### EXTENSION_LT

          public static ProgramExtensionTemplate EXTENSION_LT

      Standard boolean binary less than operator.

    - #### EXTENSION_GTE

          public static ProgramExtensionTemplate EXTENSION_GTE

      Standard boolean binary greater than operator.

    - #### EXTENSION_LTE

          public static ProgramExtensionTemplate EXTENSION_LTE

      Standard boolean binary less than operator.

    - #### EXTENSION_ABS

          public static ProgramExtensionTemplate EXTENSION_ABS

      Standard numeric absolute value function.

    - #### EXTENSION_ACOS

          public static ProgramExtensionTemplate EXTENSION_ACOS

      Standard numeric acos function.

    - #### EXTENSION_ASIN

          public static ProgramExtensionTemplate EXTENSION_ASIN

      Standard numeric asin function.

    - #### EXTENSION_ATAN

          public static ProgramExtensionTemplate EXTENSION_ATAN

      Standard numeric atan function.

    - #### EXTENSION_ATAN2

          public static ProgramExtensionTemplate EXTENSION_ATAN2

      Standard numeric atan2 function.

    - #### EXTENSION_CEIL

          public static ProgramExtensionTemplate EXTENSION_CEIL

      Standard numeric ceil function.

    - #### EXTENSION_COS

          public static ProgramExtensionTemplate EXTENSION_COS

      Standard numeric cos function.

    - #### EXTENSION_COSH

          public static ProgramExtensionTemplate EXTENSION_COSH

      Standard numeric cosh function.

    - #### EXTENSION_EXP

          public static ProgramExtensionTemplate EXTENSION_EXP

      Standard numeric exp function.

    - #### EXTENSION_FLOOR

          public static ProgramExtensionTemplate EXTENSION_FLOOR

      Standard numeric floor function.

    - #### EXTENSION_LOG

          public static ProgramExtensionTemplate EXTENSION_LOG

      Standard numeric log function.

    - #### EXTENSION_LOG10

          public static ProgramExtensionTemplate EXTENSION_LOG10

      Standard numeric log10 function.

    - #### EXTENSION_MAX

          public static ProgramExtensionTemplate EXTENSION_MAX

      Standard numeric max function.

    - #### EXTENSION_MIN

          public static ProgramExtensionTemplate EXTENSION_MIN

      Standard numeric max function.

    - #### EXTENSION_POWFN

          public static ProgramExtensionTemplate EXTENSION_POWFN

      Standard numeric pow function.

    - #### EXTENSION_RANDOM

          public static ProgramExtensionTemplate EXTENSION_RANDOM

      Standard numeric random function.

    - #### EXTENSION_ROUND

          public static ProgramExtensionTemplate EXTENSION_ROUND

      Standard numeric log10 function.

    - #### EXTENSION_SIN

          public static ProgramExtensionTemplate EXTENSION_SIN

      Standard numeric sin function.

    - #### EXTENSION_SINH

          public static ProgramExtensionTemplate EXTENSION_SINH

      Standard numeric sinh function.

    - #### EXTENSION_SQRT

          public static ProgramExtensionTemplate EXTENSION_SQRT

      Standard numeric sqrt function.

    - #### EXTENSION_TAN

          public static ProgramExtensionTemplate EXTENSION_TAN

      Standard numeric tan function.

    - #### EXTENSION_TANH

          public static ProgramExtensionTemplate EXTENSION_TANH

      Standard numeric tanh function.

    - #### EXTENSION_TODEG

          public static ProgramExtensionTemplate EXTENSION_TODEG

      Standard numeric toDegrees function.

    - #### EXTENSION_TORAD

          public static ProgramExtensionTemplate EXTENSION_TORAD

      Standard numeric toRadians function.

    - #### EXTENSION_LENGTH

          public static ProgramExtensionTemplate EXTENSION_LENGTH

      Standard string length function.

    - #### EXTENSION_FORMAT

          public static ProgramExtensionTemplate EXTENSION_FORMAT

      Numeric formatting function.

    - #### EXTENSION_LEFT

          public static ProgramExtensionTemplate EXTENSION_LEFT

      String left function.

    - #### EXTENSION_RIGHT

          public static ProgramExtensionTemplate EXTENSION_RIGHT

      String right function.

    - #### EXTENSION_CINT

          public static ProgramExtensionTemplate EXTENSION_CINT

      Standard string cint function.

    - #### EXTENSION_CFLOAT

          public static ProgramExtensionTemplate EXTENSION_CFLOAT

      Standard string cfloat function.

    - #### EXTENSION_CSTR

          public static ProgramExtensionTemplate EXTENSION_CSTR

      Standard string cstr function.

    - #### EXTENSION_CBOOL

          public static ProgramExtensionTemplate EXTENSION_CBOOL

      Standard string cbool function.

    - #### EXTENSION_IFF

          public static ProgramExtensionTemplate EXTENSION_IFF

      Standard string iff function.

    - #### EXTENSION_CLAMP

          public static ProgramExtensionTemplate EXTENSION_CLAMP

      Standard string clamp function.

  - ### Constructor Detail

    - #### StandardExtensions

          public StandardExtensions()

  - ### Method Detail

    - #### createAll

          public static void createAll(EncogProgramContext context)

      Add all known opcodes to a context.
      Parameters:
        `context` - The context to add the opcodes to.

    - #### createBasicFunctions

          public static void createBasicFunctions(EncogProgramContext context)

      Add the opcodes for basic operations to a context.
      Parameters:
        `context` - The context to add the opcodes to.

    - #### createBooleanOperators

          public static void createBooleanOperators(EncogProgramContext context)

      Add the opcodes for boolean operations to a context.
      Parameters:
        `context` - The context to add the opcodes to.

    - #### createConversionFunctions

          public static void createConversionFunctions(EncogProgramContext context)

      Add the opcodes for type conversion operations to a context.
      Parameters:
        `context` - The context to add the opcodes to.

    - #### createNumericOperators

          public static void createNumericOperators(EncogProgramContext context)

      Add the opcodes for numeric operations to a context, do not use protected division.
      Parameters:
        `context` - The context to add the opcodes to.

    - #### createNumericOperators

          public static void createNumericOperators(EncogProgramContext context,
                                    boolean protectedDiv)

      Add the opcodes for numeric operations to a context.
      Parameters:
        `context` - The context to add the opcodes to.
        `protectedDiv` - Should protected division be used.

    - #### createStringFunctions

          public static void createStringFunctions(EncogProgramContext context)

      Add the opcodes for string operations to a context.
      Parameters:
        `context` - The context to add the opcodes to.

    - #### createTrigFunctions

          public static void createTrigFunctions(EncogProgramContext context)

      Add the opcodes for trig functions operations to a context.
      Parameters:
        `context` - The context to add the opcodes to.

Copyright © 2014. All Rights Reserved.